-- HTZT150KabSounds.lua
-- Script for Fendt Farmer 310/312 LSA
--
-- Author Rival
-- 05.01.2016
-- Version 1.1 @26.10.2016
	--> converted to FS17
-- Version 1.2 @05.11.2016
	--> added indoorsound change when door/windows are open

HTZT150KabSounds = {};

function HTZT150KabSounds.prerequisitesPresent(specializations)
    return true;
end;

function HTZT150KabSounds:load(savegame)
	
	self.soundAdj = {};
	local i=0;
    while true do
        local key = string.format("vehicle.indoorsoundAdjustment.animation(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local animName = getXMLString(self.xmlFile, key.."#name");
        local lowpassGain = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#lowpassGain"), 0.5);
        local volumeFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#volumeFactor"), 0.5);
		self.soundAdj[i] = {};
		self.soundAdj[i].animName = animName;
		self.soundAdj[i].volumeFactor = volumeFactor;
		self.soundAdj[i].lowpassGain = lowpassGain;
        i = i +1;
    end;
	
if self.isClient then
self.sampleOpenDoorH = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "Sounds/Sounds_anim/shitkiOtkr.wav", self.baseDirectory, self.components[1].node);
self.sampleCloseDoorH = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "Sounds/Sounds_anim/shitkiZakr.wav", self.baseDirectory, self.components[1].node);

self.sampleOpenDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "Sounds/Sounds_anim/Open_Door.wav", self.baseDirectory, self.components[1].node);
self.sampleCloseDoorL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "Sounds/Sounds_anim/Close_Door.wav", self.baseDirectory, self.components[1].node);

self.sampleOpenDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "Sounds/Sounds_anim/Open_Door.wav", self.baseDirectory, self.components[1].node);
self.sampleCloseDoorR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "Sounds/Sounds_anim/Close_Door.wav", self.baseDirectory, self.components[1].node);

self.sampleOpenDoorFR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "Sounds/Sounds_anim/Open_FR.wav", self.baseDirectory, self.components[1].node);
self.sampleCloseDoorFR = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "Sounds/Sounds_anim/Close_FR.wav", self.baseDirectory, self.components[1].node);

self.sampleOpenDoorFL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.openDoorSound", "Sounds/Sounds_anim/Open_FR.wav", self.baseDirectory, self.components[1].node);
self.sampleCloseDoorFL = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.closeDoorSound", "Sounds/Sounds_anim/Close_FR.wav", self.baseDirectory, self.components[1].node);

end;
end;
--function HTZT150KabSounds:postLoad(savegame)
--	for k,v in pairs(self.sampleMotor) do print(k,v) end
--end;
function HTZT150KabSounds:delete()
if self.sampleOpenDoorH ~= nil then
SoundUtil.deleteSample(self.sampleOpenDoorH);
end;
if self.sampleCloseDoorH ~= nil then
SoundUtil.deleteSample(self.sampleCloseDoorH);
end;

if self.sampleOpenDoorL ~= nil then
SoundUtil.deleteSample(self.sampleOpenDoorL);
end;
if self.sampleCloseDoorL ~= nil then
SoundUtil.deleteSample(self.sampleCloseDoorL);
end;

if self.sampleOpenDoorR ~= nil then
SoundUtil.deleteSample(self.sampleOpenDoorR);
end;
if self.sampleCloseDoorR ~= nil then
SoundUtil.deleteSample(self.sampleCloseDoorR);
end;

if self.sampleOpenDoorFR ~= nil then
SoundUtil.deleteSample(self.sampleOpenDoorFR);
end;
if self.sampleCloseDoorFR ~= nil then
SoundUtil.deleteSample(self.sampleCloseDoorFR);
end;

if self.sampleOpenDoorFL ~= nil then
SoundUtil.deleteSample(self.sampleOpenDoorFL);
end;
if self.sampleCloseDoorFL ~= nil then
SoundUtil.deleteSample(self.sampleCloseDoorFL);
end;


end;
function HTZT150KabSounds:mouseEvent(posX, posY, isDown, isUp, button)
end;
function HTZT150KabSounds:keyEvent(unicode, sym, modifier, isDown)
end;
function HTZT150KabSounds:update(dt)

if self:getIsActive() and self.isClient then
if self.isEntered then

if self:getIsAnimationPlaying("shitki") and self:getIsActiveForSound() then
if self.animations["shitki"].currentSpeed > 0 and self.animations["shitki"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleOpenDoorH, 1.5*dt) then
SoundUtil.playSample(self.sampleOpenDoorH,1,1,nil);
end;

elseif self.animations["shitki"].currentSpeed < 0 and self.animations["shitki"].currentTime < 100 then
if not SoundUtil.isSamplePlaying(self.sampleCloseDoorH, 1.5*dt) then
SoundUtil.playSample(self.sampleCloseDoorH,1,1,nil);
end;
end;
end;

if self:getIsAnimationPlaying("doorLeft") and self:getIsActiveForSound() then
if self.animations["doorLeft"].currentSpeed > 0 and self.animations["doorLeft"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleOpenDoorL, 1.5*dt) then
SoundUtil.playSample(self.sampleOpenDoorL,1,1,nil);
end;

elseif self.animations["doorLeft"].currentSpeed < 0 and self.animations["doorLeft"].currentTime < 100 then
if not SoundUtil.isSamplePlaying(self.sampleCloseDoorL, 1.5*dt) then
SoundUtil.playSample(self.sampleCloseDoorL,1,1,nil);
end;
end;
end;

if self:getIsAnimationPlaying("doorRight") and self:getIsActiveForSound() then
if self.animations["doorRight"].currentSpeed > 0 and self.animations["doorRight"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleOpenDoorR, 1.5*dt) then
SoundUtil.playSample(self.sampleOpenDoorR,1,1,nil);
end;

elseif self.animations["doorRight"].currentSpeed < 0 and self.animations["doorRight"].currentTime < 100 then
if not SoundUtil.isSamplePlaying(self.sampleCloseDoorR, 1.5*dt) then
SoundUtil.playSample(self.sampleCloseDoorR,1,1,nil);
end;
end;
end;

if self:getIsAnimationPlaying("fortochkaRight") and self:getIsActiveForSound() then
if self.animations["fortochkaRight"].currentSpeed > 0 and self.animations["fortochkaRight"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleOpenDoorFR, 1.5*dt) then
SoundUtil.playSample(self.sampleOpenDoorFR,1,1,nil);
end;

elseif self.animations["fortochkaRight"].currentSpeed < 0 and self.animations["fortochkaRight"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleCloseDoorFR, 1.5*dt) then
SoundUtil.playSample(self.sampleCloseDoorFR,1,1,nil);
end;
end;
end;

if self:getIsAnimationPlaying("fortochkaLeft") and self:getIsActiveForSound() then
if self.animations["fortochkaLeft"].currentSpeed > 0 and self.animations["fortochkaLeft"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleOpenDoorFL, 1.5*dt) then
SoundUtil.playSample(self.sampleOpenDoorFL,1,1,nil);
end;

elseif self.animations["fortochkaLeft"].currentSpeed < 0 and self.animations["fortochkaLeft"].currentTime < 50 then
if not SoundUtil.isSamplePlaying(self.sampleCloseDoorFL, 1.5*dt) then
SoundUtil.playSample(self.sampleCloseDoorFL,1,1,nil);
end;
end;
end;





			local sound=false;
			for i=0, #self.soundAdj do
				if self.animations[self.soundAdj[i].animName] ~= nil and self.animations[self.soundAdj[i].animName].currentTime > 500 then
					self.sampleMotor.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotor.indoorVolumeFactor);
					self.sampleMotor.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotor.indoorLowpassGain);
					self.sampleMotorStart.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStart.indoorVolumeFactor);
					self.sampleMotorStart.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStart.indoorLowpassGain);
					self.sampleMotorStop.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorStop.indoorVolumeFactor);
					self.sampleMotorStop.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorStop.indoorLowpassGain);
					
					self.sampleMotorRun.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorRun.indoorVolumeFactor);
					self.sampleMotorRun.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorRun.indoorLowpassGain);
					self.sampleMotorLoad.indoorVolumeFactor = math.max(self.soundAdj[i].volumeFactor, self.sampleMotorLoad.indoorVolumeFactor);
					self.sampleMotorLoad.indoorLowpassGain = math.max(self.soundAdj[i].lowpassGain, self.sampleMotorLoad.indoorLowpassGain);
					sound=true;
				else
					if not sound then
						self.sampleMotor.indoorVolumeFactor = 0.55;
						self.sampleMotor.indoorLowpassGain = 0.2;
						self.sampleMotorStart.indoorVolumeFactor = 0.55;
						self.sampleMotorStart.indoorLowpassGain = 0.2;
						self.sampleMotorStop.indoorVolumeFactor = 0.55;
						self.sampleMotorStop.indoorLowpassGain = 0.2;
						
						self.sampleMotorRun.indoorVolumeFactor = 0.6;
						self.sampleMotorRun.indoorLowpassGain = 0.2;
						self.sampleMotorLoad.indoorVolumeFactor = 0.6;
						self.sampleMotorLoad.indoorLowpassGain = 0.2;
					end;
				end;
			end;
			SoundUtil.onCameraSwitched(self.activeCamera.isInside);
		end;
    end;
end;
function HTZT150KabSounds:updateTick(dt)
end;
function HTZT150KabSounds:draw()    
end;